package htLuokat;

/**
 * @author jaakk
 * @version 2 Mar 2022
 *
 */
public class Kayttajat {
    
    private static final int MAX_KAYTTAJAT = 10;
    
//    private Kayttaja[] kayttajat;
    private Kayttaja[] kayttajat = new Kayttaja[MAX_KAYTTAJAT];
    private int lkm = 0;
    
/**
 *  luodaaan uusi kayttajat olio
 */
public Kayttajat() {
//    Kayttaja uusi = new Kayttaja();
//    for(int i = 0; i + 1 < kayttajat.length; i++) {
//        kayttajat[i] = uusi;
        
//    }
}
    
    
    /**
     * @param args ei käytössä
     * 
     */
    public static void main(String[]args)  {
        
    Kayttajat kayttajat1 = new Kayttajat();
    
    Kayttaja pohja = new Kayttaja();     
    Kayttaja juvonen = new Kayttaja();
    Kayttaja jokisalo = new Kayttaja();

   
        
        try {
            kayttajat1.lisaa(juvonen);
            kayttajat1.lisaa(pohja);
            kayttajat1.lisaa(jokisalo);
        } catch (SailoException e) {
            System.err.println(e.getMessage());
        }

        
        juvonen.rekisteroi();
        jokisalo.rekisteroi();
        pohja.rekisteroi();
        
        
        juvonen.tayta();
    }
    
    /**
     * @param kayttaja käyttäjä
     * @throws SailoException heittää jos liikaa käytäjiä
     */
    public void lisaa(Kayttaja kayttaja) throws SailoException {
        if(lkm >= kayttajat.length) throw new SailoException("Liikaa käyttäjiä!");
        kayttajat[lkm] = kayttaja;
        lkm++;
       
    }
    
    /**
     * palauttaa viitteen jäseneen
     * @param i mones jäsen halutaan
     * @return viite jäseneen
     * @throws IndexOutOfBoundsException jos i ei sallitulla alueella
     */
    public Kayttaja anna(int i) throws IndexOutOfBoundsException {
        if(i < 0 || lkm <= i)
            throw new IndexOutOfBoundsException("Laiton indeksi" + i);
        return kayttajat[i];
    }
    

    
    /**
     * @return pituuden
     */
    public int getlength() {
        return lkm;
    }
    
    /**
     * @param paikka paikka josta kayttaja otetaan 
     * @return palauttaa kayttajan
     */
    public Kayttaja haeKayttaja(int paikka) {
        return kayttajat[paikka];
    }


 
    
    
    
}
