package htLuokat;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * @author jaakk
 * @version 2 Mar 2022
 *
 */
public class Kayttaja {

    
    private int id;
    private String nimi = "janne";
    
    
    private static int seuraavaNro = 1;
    
    /**
     * 
     */
    public Kayttaja() {
     
    }
    
    /**
     * 
     */
    public Kayttaja(String nimi) {
     this.nimi = nimi;
    }
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Kayttaja juvonen = new Kayttaja();
        Kayttaja jokisalo = new Kayttaja();
        Kayttaja pohja = new Kayttaja();

        
        juvonen.rekisteroi();
        jokisalo.rekisteroi();
        pohja.rekisteroi();
        
        
        juvonen.tayta();
        juvonen.tulosta(System.out);
        pohja.tayta();
        pohja.tulosta(System.out);
        jokisalo.tayta();
        jokisalo.tulosta(System.out);
        
        
        
    }
    

    
    /**
     * tulostaa käyttäjän tiedot
     * @param out tietovirta 
     */
    public void tulosta(PrintStream out) {
        out.println(nimi + ", ID: " + id);
    }
    
    /**
     * tulostaa henkilön tiedot
     * @param os tietovirta
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    
    
    /**
     * rekisteröi uuden kayttäjän
     * @return käyttäjän id numero
     */
    public int rekisteroi() {
        this.id = seuraavaNro;
        seuraavaNro++;
        return this.id;
    }
    
    /**
     * täytetään käytäjän tiedot
     */
    public void tayta() {
        nimi = "Meikä Mandoliini"; 
    }
    
    /**
     * @return nimi
     * 
     */
    public String getNimi() {
        return nimi;
    }
    

    
    
 
}
