package htScene;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import htLuokat.Kayttaja;
import htLuokat.KotityoRekisteri;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.Pane;

/**
 * @author leevi
 * @version 9 Mar 2022
 *
 */
public class KayttajaController {
    ////test
    KotityoRekisteri rekisteri = new KotityoRekisteri();
    
    private ListChooser<Object> kohdeValitsin; // leevi 5 vaihe kayttajat
    
    @FXML
    private Pane lisaaKayttaja;

    @FXML
    private Button eiku;

    @FXML
    private TextField nimitext;

    @FXML
    private Button ok;

    @FXML
    void handleEiku() {
       handlePeruutus();
    }

    @FXML
    void handleOk() {
       handleTallennus();
    }

    //==================================================
    // fxml juttuja ^
    
    
    private void handlePeruutus() {

        ModalController.closeStage(lisaaKayttaja);
    }
    
    private void handleTallennus() {
        Kayttaja uusi = new Kayttaja();
        rekisteri.lisaaKayttaja(uusi);
        
    
        Dialogs.showMessageDialog("Tässä kohtaa tallenetaan suoritus(ei osata vielä)");
        ModalController.closeStage(lisaaKayttaja);
        
        hae();

    }
    
    /**
     * 
     */
    public void hae() {
        kohdeValitsin.clear();
        for(int i = 0; i < rekisteri.kayttajienLkm(); i++)
        {
            Kayttaja lisattava = rekisteri.haeKayttaja(i);
            kohdeValitsin.add(lisattava.getNimi(), lisattava);
        }
        
        
    }
    
    /**
     * @param rekisteri rekisteri
     */
    // test
    
    public void setrekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri; 
    }

    /**
     * @param kohdeValitsin2 listchooser
     */
    public void setValitsin( ListChooser<Object> kohdeValitsin2 ) {
       
        this.kohdeValitsin = kohdeValitsin2;
    }
    
    
}
