package htScene;

import htLuokat.KotityoRekisteri;
import htLuokat.TehtavaLokit;
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;


/**
 * @author jaakk
 * @version 31.1.2022
 *
 */
public class KotityoMain extends Application {
    @Override
    public void start(Stage primaryStage) {
        try {
            FXMLLoader ldr = new FXMLLoader(getClass().getResource("etusivuView.fxml")); 
            final Pane root = ldr.load();
            //
            final EtusivuController kotityoCtrlT = (EtusivuController)ldr.getController();
            //
         
//            final EtusivuController kotityoCtrl = (EtusivuController)ldr.getController();
            
            Scene scene = new Scene(root);
            scene.getStylesheets().add(getClass().getResource("kotityo.css").toExternalForm());
            primaryStage.setScene(scene);
            primaryStage.setTitle("kotityo");
            
//            TehtavaLokit loki = new TehtavaLokit(); vanha
     
//            kotityoCtrl.setLoki(loki);  vanha
            
            
            //TESTIA
          
           KotityoRekisteri rekisteri = new KotityoRekisteri();
           kotityoCtrlT.setRekisteri(rekisteri);
           
           kotityoCtrlT.setLoki(rekisteri.getLoki());
           
            
            // vaiha 
            
            primaryStage.show();
       //     if( !(kotityoCtrl.avaa()))Platform.exit();
            
            
            
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * @param args Ei käytössä
     */
    public static void main(String[] args) {
        launch(args);
    }
}