package htScene;
import java.io.PrintStream;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import htLuokat.Huone;
import htLuokat.Kayttaja;
import htLuokat.KotityoRekisteri;
import htLuokat.Tehtava;
import htLuokat.TehtavaLoki;
import javafx.fxml.FXML;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.TextArea;
import javafx.scene.layout.Pane;
import javafx.scene.text.Font;

/**
 * @author leevi
 * @version 31.1.2022
 *
 */
public class SuoritusController {
    
    /// suorituksen lisaaminen
    

    KotityoRekisteri rekisteri = new KotityoRekisteri();
     private ScrollPane panelSuoritus = new ScrollPane();

     private  TextArea tulostusview = new TextArea();
    
    ///

        @FXML
        private Pane suoritus;



    @FXML
    void handlePeruuta() {
     peruuta();
    }

    @FXML
    void handleSuorita() {
      suorita();
    }
    
   
    // ==========================
    
    
    /**
     * @param rekisteri rekisteri
     */
    public void setrekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri;
    }
    
    
    
    private void peruuta() {
        
        ModalController.closeStage(suoritus);
       
    }
    
    private void suorita(){
        Dialogs.showMessageDialog("Tässä kohtaa tallenetaan suoritus(ei osata vielä)");
     
        
        TehtavaLoki suoritus1 = new TehtavaLoki();
        Huone huone =  new Huone("keittio");
        Tehtava tehtava =  new Tehtava("Imurointi");
        Kayttaja kayttaja = new Kayttaja();
      
        suoritus1.lisaaHuone(huone);
        suoritus1.lisaaTehtava(tehtava);
        suoritus1.lisaaKayttaja(kayttaja);
        
       
        
       rekisteri.lisaa(suoritus1);
       
       
        tulosta(suoritus1);
        ModalController.closeStage(suoritus);
    }
    
    /**
     * 
     */
    public void alusta() {
        panelSuoritus.setContent(tulostusview);
        tulostusview.setFont(new Font("Courier New", 12));
        panelSuoritus.setFitToHeight(true);

        
    }

    /**
     * @param suoritus suoritus joka tulostetaan
     */
    public  void tulosta(TehtavaLoki suoritus) {
        
        
               tulostusview.setText("");
                try (PrintStream os = TextAreaOutputStream.getTextPrintStream(tulostusview)) {
                     suoritus.tulosta(os);
                } catch (Exception e) {
                    System.err.println(e.getMessage()); 
                    } 
     
       
    }

    /**
     * @param panelSuoritus panel 
     * @param tulostusview tulostus
     */
    public void setTulostus(ScrollPane panelSuoritus,  TextArea tulostusview) {
        this.tulostusview = tulostusview;
        this.panelSuoritus = panelSuoritus;
        
    }

}

   
   

